﻿using GalaSoft.MvvmLight;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel;
using GalaSoft.MvvmLight.Command;
using GalaSoft.MvvmLight.Messaging;
using System.Diagnostics;
using System.Threading;
using System.Collections.ObjectModel;

namespace ClickToGet.ViewModel
{
    public class BOMViewModel : ViewModelBase
    {


        private Task updateSearchSuggested_Task;

        private string search;
        public string Search
        {
            get
            {
                return search;
            }
            set
            {
                if (search == value) return;
                search = value;
                RaisePropertyChanged("Search");

                //Asynchronous
                updateSearchSuggested_Task = new Task(UpdateSearchSuggested_Thread);
                updateSearchSuggested_Task.Start();

                //Synchronous
                /*SearchSuggested = new ObservableCollection<string>();
                SearchSuggested.Add("Test1");
                SearchSuggested.Add("Test2");
                SearchSuggested.Add("Test3");*/
            }
        }


        private ObservableCollection<string> searchSuggested;
        public ObservableCollection<string> SearchSuggested
        {
            get
            {
                return searchSuggested;
            }
            set
            {
                if (searchSuggested == value) return;
                searchSuggested = value;
                RaisePropertyChanged("SearchSuggested");
            }
        }


        public BOMViewModel()
        {
            SearchSuggested = new ObservableCollection<string>();
        }


        private void UpdateSearchSuggested_Thread()
        {
            Debug.WriteLine("Start UpdateSearchSuggested_Thread");
            SearchSuggested = new ObservableCollection<string>();
            SearchSuggested.Add("Test1");
            SearchSuggested.Add("Test2");
            SearchSuggested.Add("Test3");
            Debug.WriteLine("End UpdateSearchSuggested_Thread");
        }
    }
}
